package com.maplehaze.adsdk.demo;


import android.app.Application;
import android.text.TextUtils;
import android.util.Log;

import com.maplehaze.adsdk.MaplehazeAdConfig;
import com.maplehaze.adsdk.MaplehazeSDK;
import com.maplehaze.adsdk.demo.utils.SharePfUtil;
import com.tanx.onlyid.api.DeviceID;
import com.tanx.onlyid.api.IGetter;

public class DemoApplication extends Application {
    private static String TAG = "maplehaze";

    @Override
    public void onCreate() {
        super.onCreate();
        Log.i(TAG, "demo application");
        initOAID();
    }

    private void initSdk(String oaid) {
        MaplehazeAdConfig maplehazeAdConfig = new MaplehazeAdConfig();
        maplehazeAdConfig.setAppId(Constants.APP_ID);//设置appid

        /////////////////配置可选//////////////////////////
        maplehazeAdConfig.setDebug(true);//log开关 true打开，false关闭(默认)
        maplehazeAdConfig.setShowDownloadToast(true); //下载应用是否有toast提醒开始下载
        maplehazeAdConfig.setOaid(oaid);//如媒体侧已经集成了OAID SDK，可以通过setOAID接口传入oaid，而不必集成枫岚提供的oaid_1.0.25.aar
//        maplehazeAdConfig.setAppList(getAppList());  //如果不希望sdk 获取app安装列表
//        maplehazeAdConfig.setPersonalizedState(0);  // 0不屏蔽个性化推荐广告,1屏蔽个性化推荐广告
        /////////////////配置可选//////////////////////////
        MaplehazeSDK.getInstance().init(this, maplehazeAdConfig);
        // MaplehazeSDK.getInstance().isInitFinish() 判断是否初始化完成
        // MaplehazeSDK.getVersion(); 获取sdk版本
    }

    private void initOAID() {
        try {
            // 初始化MSA SDK
            //获取OAID

            String oaid = SharePfUtil.getOAID(getApplicationContext());
            if (!TextUtils.isEmpty(oaid)) {
                Log.e(TAG, "getOAID use cache");
                initSdk(oaid);
            } else {
                Log.e(TAG, "getOAID");
//                int sdkState = com.bun.miitmdid.core.MdidSdkHelper.InitSdk(getApplicationContext(), true, new com.bun.miitmdid.interfaces.IIdentifierListener() {
//                    @Override
//                    public void OnSupport(boolean b, IdSupplier idSupplier) {
//                        try {
//                            if (idSupplier != null) {
//                                String oaid = idSupplier.getOAID();
//                                SharePfUtil.saveOAID(getApplicationContext(), oaid);
//                                Log.e(TAG, "oaid=" + oaid);
//                                initSdk(oaid);
//                            }
//                        } catch (Throwable ignored) {
//                        }
//                    }
//                });

                DeviceID.getOAID(this, new IGetter() {
                    @Override
                    public void oaidSucc(String s) {
                        initSdk(s);
                    }

                    @Override
                    public void oaidError(Exception e) {

                    }
                });
            }


        } catch (Throwable e) {
            initSdk("");
            Log.e(TAG, "getOAID", e);
        }
    }

//    private List<AppData> getAppList() {
//        List<AppData> apps = new ArrayList<>();
//        AppData appData1 = new AppData();
//        appData1.setAppName("拼多多");
//        appData1.setPackageName("com.pdd");
//        apps.add(appData1);
//
//        AppData appData2 = new AppData();
//        appData2.setAppName("京东");
//        appData2.setPackageName("com.jd");
//        apps.add(appData2);
//        return apps;
//    }
}
